/*
 * sagittarius/private.h: Sagittarius scheme system private header.
 *
 *   Copyright (c) 2010-2021  Takashi Kato <ktakashi@ymail.com>
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  $Id: $
 */
#ifndef SAGITTARIUS_PRIVATE_H_
#define SAGITTARIUS_PRIVATE_H_

/* 
   !CAUTION!
   The C APIs listed in the below files subjected to change anytime
   without warnings. Please use it with your responsibility.

   If you want to avoid the backward incompatibility, please use the
   public APIs.
 */
#include "private/sagittariusdefs.h"
#include "private/bignum.h"
#include "private/mbignum.h"
#include "private/bytevector.h"
#include "private/charset.h"
#include "private/cache.h"
#include "private/clos.h"
#include "private/closure.h"
#include "private/code.h"
#include "private/codec.h"
#include "private/compare.h"
#include "private/core.h"
#include "private/error.h"
#include "private/exceptions.h"
#include "private/file.h"
#include "private/generic.h"
#include "private/gloc.h"
#include "private/hashtable.h"
#include "private/identifier.h"
#include "private/keyword.h"
#include "private/library.h"
#include "private/load.h"
#include "private/macro.h"
#include "private/number.h"
#include "private/pair.h"
#include "private/port.h"
#include "private/profiler.h"
#include "private/reader.h"
#include "private/record.h"
#include "private/regex.h"
#include "private/string.h"
#include "private/symbol.h"
#include "private/subr.h"
#include "private/system.h"
#include "private/thread.h"
#include "private/transcoder.h"
#include "private/treemap.h"
#include "private/unicode.h"
#include "private/weak.h"
#include "private/writer.h"
#include "private/values.h"
#include "private/vector.h"
#include "private/vm.h"

#endif /* SAGITTARIUS_H_ */

/*
  end of file
  Local Variables:
  coding: utf-8-unix
  End:
*/
